<?php declare(strict_types=1);

use danog\MadelineProto\{
    API,
    SimpleEventHandler,
    Settings,
    VoIP,

    RemoteUrl,
    LocalFile,
    Logger
    
};
use danog\MadelineProto\EventHandler\Filter\{
    FilterOutgoing,
    FilterIncoming,
    FilterFromAdmin,
    FilterRegex,
    FilterCommand,
    FilterTextCaseInsensitive,
    FilterText,
    FilterFromSenders, // I am not using this but just for showing
    FilterButtonQueryData
};
use danog\MadelineProto\Broadcast\Progress;
use danog\MadelineProto\Broadcast\Status;
use danog\MadelineProto\EventHandler\Attributes\Cron;
use danog\MadelineProto\EventHandler\Attributes\Handler;
use danog\MadelineProto\EventHandler\CallbackQuery;

use danog\MadelineProto\EventHandler\Message\{ PrivateMessage, GroupMessage ,ChannelMessage };
use danog\MadelineProto\EventHandler\Filter\Combinator\{ FiltersOr, FiltersAnd };

use danog\MadelineProto\EventHandler\Message;
// use danog\MadelineProto\EventHandler\Message\ChannelMessage;
use danog\MadelineProto\EventHandler\Message\Service\DialogPhotoChanged;
use danog\MadelineProto\EventHandler\Plugin\RestartPlugin;
use danog\MadelineProto\EventHandler\SimpleFilter\FromAdmin;
use danog\MadelineProto\EventHandler\SimpleFilter\Incoming;
use danog\MadelineProto\EventHandler\SimpleFilter\IsReply;
use danog\MadelineProto\EventHandler\SimpleFilter\HasMedia;


use danog\MadelineProto\Settings\Database\Mysql;
use danog\MadelineProto\Settings\Database\Postgres;
use danog\MadelineProto\Settings\Database\Redis;



use danog\MadelineProto\ParseMode;








require_once 'mrmdsql.php';

$Db_Name = "iiioewsi_CopyBot";
$Db_Username = "iiioewsi_CopyBot";
$Db_Password = 'oL5(&TtgIin@';

$db = new Database('localhost', $Db_Name, $Db_Password,$Db_Username);

class MyEventHandler extends SimpleEventHandler
{
    /**
     * @var int|string Username or ID of bot admin
     */
    public const ADMIN = "@massaleh7"; // !!! Change this to your username !!!


    public function __sleep(): array
    {
        return ['notifiedChats'];
    }

    /**
     * Get peer(s) where to report errors.
     *
     * @return int|string|array
     */
    public function getReportPeers()
    {
        return [self::ADMIN];
    }
    /**
     * Initialization logic.
     */
    public function onStart(): void
    {
        // $this->logger("The bot was started!");
        // $this->logger($this->getFullInfo('MadelineProto'));

        // $this->sendMessageToAdmins("The bot was started!");
    }

    /**
     * Returns a set of plugins to activate.
     */
    public static function getPlugins(): array
    {
        return [
            // Offers a /restart command to admins that can be used to restart the bot, applying changes.
            // Make sure to run in a bash while loop when running via CLI to allow self-restarts.
            RestartPlugin::class,
        ];
    }

    /**
     * This cron function will be executed forever, every 60 seconds.
     */
    #[Cron(period: 60.0)]
    public function cron1(): void
    {
        // $this->sendMessageToAdmins("The bot is online, current time ".date(DATE_RFC850)."!");
    }

    public function fileid($replyToId){
        $types = [
            'audio',
            'document',
            'photo',
            'sticker',
            'video',
            'voice',
            'video_note',
            'animation'
        ];
        
        $getmessage =  $this->messages->getMessages([
            'id' => [$replyToId]
        ])['messages'][0];

        // $getmessage =  $this->channels->getMessages([
        //     'channel' => $peer,
        //     'id' => [$replyToId]
        // ])['messages'][0];




        $botAPI_file =  $this->MTProtoToBotAPI($getmessage['media']);
        
        foreach ($types as $type) {
            if (isset($botAPI_file[$type]) && is_array($botAPI_file[$type])) {
                $method = $type;
            }
        }
        
        $result['file_type'] = $method;
        if ($result['file_type'] == 'photo') {
            $item = end($botAPI_file[$method]);
            $result['file_size'] = $item['file_size'];
            if (isset($item['file_name'])) {
                $result['file_name'] = $item['file_name'];
                $result['file_id']   = $item['file_id'];
            }
        }
        else {
            if (isset($botAPI_file[$method]['file_name'])) {
                $result['file_name'] = $botAPI_file[$method]['file_name'];
            }
            if (isset($botAPI_file[$method]['file_size'])) {
                $result['file_size'] = $botAPI_file[$method]['file_size'];
            }
            if (isset($botAPI_file[$method]['mime_type'])) {
                $result['mime_type'] = $botAPI_file[$method]['mime_type'];
            }
            $result['file_id'] = $botAPI_file[$method]['file_id'];
        }
        if (!isset($result['mime_type'])) {
            $result['mime_type'] = 'application/octet-stream';
        }
        if (!isset($result['file_name'])) {
            $result['file_name'] = $result['file_id'].($method === 'sticker' ? '.webp' : '');
        }
    
    // var_export($result);
    return $result;
    }

    public function Handel_Errors($error){
    
        switch ($error) {
            case "STORY_NOT_EXISTS":
                return "This user has no story!";
            case "USER_DATA_NOT_FOUND":
                return "User Data Not Found!";
            case "USER_NOT_FOUND":
                return "User Not Found!";
            default:
                return "Error";
        }
        
    }

    public function copy(mixed $from, mixed $to, int $id, bool $copyCaption = true, bool $copyQuote = false) {
    $type =  $this->getInfo($from)['type'];
    $type = (($type == 'supergroup' || $type == 'channel') ? 'channels':'messages');
    $res = ( $this->{$type}->getMessages([
        'channel' => $from,
        'id' => range($id - 9, $id + 9),
    ]))['messages'];
    $ids = [];
    if(isset($res[9]['grouped_id'])){
        foreach($res as $value)
            if(($value['grouped_id'] ?? 0) == $res[9]['grouped_id'])
                $ids[] = $value['id'];
    }else
        $ids[] = $res[9]['id'];
    $res =  $this->messages->forwardMessages([
        'drop_author'         => !$copyQuote,
        'drop_media_captions' => !$copyCaption,
        'from_peer'           => $from,
        'id'                  => $ids,
        'to_peer'             => $to
    ]);
    return array_values(array_filter(
        $res['updates'],
        function($input){
            return (($input['pts_count'] ?? 0) == 1);
        }
    ));
}

    public function copy2(mixed $from, mixed $to, int $id, bool $copyCaption = true, bool $copyQuote = false)
    {
        $type =  $this->getInfo($from)['type'];
        $type = (($type == 'supergroup' || $type == 'channel') ? 'channels':'messages');
        $res = ( $this->{$type}->getMessages([
            'channel' => $from,
            'id' => range($id - 9, $id + 9),
        ]))['messages'];
        $ids = [];
        if(isset($res[9]['grouped_id'])){
            foreach($res as $value)
                if(($value['grouped_id'] ?? 0) == $res[9]['grouped_id'])
                    $ids[] = $value['id'];
        }else
            $ids[] = $res[9]['id'];
        $res =  $this->messages->forwardMessages([
            'drop_author'         => !$copyQuote,
            'drop_media_captions' => !$copyCaption,
            'from_peer'           => $from,
            'id'                  => $ids,
            'to_peer'             => $to
        ]);
        return array_values(array_filter(
            $res['updates'],
            function($input){
                return (($input['pts_count'] ?? 0) == 1);
            }
        ));
    }

    public function copy3($message ,mixed $from, mixed $to, int $id, bool $copyCaption = true, bool $copyQuote = false)
    {
        $type =  $this->getInfo($from)['type'];
        $type = (($type == 'supergroup' || $type == 'channel') ? 'channels':'messages');
        $res = ( $this->{$type}->getMessages([
            'channel' => $from,
            'id' => range($id - 9, $id + 9),
        ]))['messages'];
        $ids = [];
        $Links = [];
        // $single = [];
        if(isset($res[9]['grouped_id'])){
            foreach($res as $value)
                if(($value['grouped_id'] ?? 0) == $res[9]['grouped_id'])
                    $ids[] = $value['id'];
                    $output_file_name =  $this->downloadToDir($message, './Downloads/');
                    // $this->messages->sendMessage(['peer' => $to,'message' => "ok*-$output_file_name"]);

                    $Links[] = $output_file_name;
                    $output_file_name = str_replace("/home1/vfvsdvco/public_html","https://www.filim0.site",$output_file_name);
                    $single[] = [
                        '_' => 'inputSingleMedia',
                        'media' => [
                            '_' => 'inputMediaUploadedDocument',
                            'file' => $output_file_name,
                            'attributes' => [
                                [
                                    '_' => 'documentAttributeFilename',
                                    'file_name' => "file"
                                ]
                            ]
                        ]
                    ];

        }else{
            $ids[] = $res[9]['id'];
        }
        

        return $this->messages->sendMultiMedia(
            peer : $to,
            multi_media: $single
        );

        // $res =  $this->messages->forwardMessages([
        //     'drop_author'         => !$copyQuote,
        //     'drop_media_captions' => !$copyCaption,
        //     'from_peer'           => $from,
        //     'id'                  => $ids,
        //     'to_peer'             => $to
        // ]);
        // return array_values(array_filter(
        //     $res['updates'],
        //     function($input){
        //         return (($input['pts_count'] ?? 0) == 1);
        //     }
        // ));
    }

    public  function hasMedia(array $message = [], bool $allowWebPage = false) {
        
        $mediaType = $message['media']['_'] ?? 'text';
        if ($mediaType === 'text') {
            return true;
        }
        if ( $mediaType === 'messageMediaWebPage' && ($allowWebPage === false || empty($message['media']['webpage']['photo'])))   {
            return false;
        }   
        return false;
    }
  
    public  function hasMedia2(array $message = []): string {

        $mediaType = $message['media']['_'] ?? 'text';
        $explode = explode('messageMedia',$mediaType);

        if ($mediaType === 'text') {
            return 'Text';
          }
        if ($explode[1]=='Document') {
            // if($message['media']['document']['attributes'][0]['_'] === 'documentAttributeVideo' && $message['media']['document']['attributes'][2]['_'] !== 'documentAttributeAnimated')
            if($message['media']['document']['attributes'][0]['_'] === 'documentAttributeVideo')
            {
                // $A = '{
                // "round_message" : "false" ,
                // "supports_streaming" : "true",
                // "duration" : '.$message['media']['document']['attributes'][0]['duration'].',
                // "w" : '.$message['media']['document']['attributes'][0]['w'].',
                // "h" : '.$message['media']['document']['attributes'][0]['h'].'

                // }';
                // file_put_contents('Folders/video/data.json',$A);
                return    'documentAttributeVideo';
            }
            if(isset($message['media']['document']['attributes'][2]['_'] )!=false){
                if($message['media']['document']['attributes'][2]['_'] == 'documentAttributeAnimated'){
                return 'documentAttributeAnimated';
                }
            }
        
            if(isset($message['media']['document']['attributes'][0]['voice'] )!=false){
                if($message['media']['document']['attributes'][0]['voice'] == 'true'){
                    return 'voice';

                }else{
                    return 'audio';
            }
          }

            if($message['media']['document']['attributes'][0]['_'] ){
                if($message['media']['document']['attributes'][0]['_'] == 'documentAttributeImageSize'){
                    return 'Sticker';

                }else{
                    return 'audio';
            }
          }

        }
        elseif ($explode[1]=='WebPage') {
            // return 'WebPage';
            return 'Text';
          }
        elseif ($explode[1]=='Photo') {
            return 'Photo';
          }

          return 'NO post';
    } //ME


    #[FilterText('restart')]
    public function restarting(Message & FromAdmin $message): void
    {
        $message->reply('restarted!');
        $this->restart();
    }
// -----------------------------------------------------------------------------------------

    # --------- Check Online Bot,Copy,Tag 
    #[FiltersAnd(
        new FiltersOr(new FilterOutgoing, new FilterFromAdmin),
        new FilterRegex("/^[\/\#\!]?(bot|tag|copy) (on|off)$/i")
    )]
    public function check(Message $message)
    {
        global $db;
        $TEXT = $message->message;
        preg_match("/^[\/\#\!]?(bot|tag|copy) (on|off)$/i", $TEXT, $Data);
        
        $db->update('checkdata', [$Data[1] => $Data[2]], ['num' => 1]);
        
        $result = $db->select('checkdata',  $Data[1], ['num' => 1]);
        foreach ($result as $row) {
            return $message->reply($Data[1]." ==> ".$row[$Data[1]]." ✅");
        
        }
    }


    # --------- Add Channels
    #[FiltersAnd(
        new FiltersOr(new FilterOutgoing, new FilterFromAdmin),
        new FilterRegex("/^[\/\#\!]?(channels) (.*)$/i")
    )]
    public function Add_channel(Message $message): void
    {
        global $db;
        $TEXT = $message->message;
        preg_match("/^[\/\#\!]?(channels) (.*)$/i", $TEXT, $Data);
        $chnnels = explode('|',$Data[2]);
        $MABDA = $chnnels[0];
        $MAQSAD = $chnnels[1];
        $Tag = $chnnels[2]??"";
        $result = $db->has('channels', ['mabda' => $MABDA , 'maqsad' => $MAQSAD]);
        foreach ($result as $row) {
            if($row['has'] == 0){
                $db->insert('channels', ['mabda' => $MABDA, 'maqsad' => $MAQSAD,"tag"=>'-']);
                $res = "کانال مبدا و مقصد ثبت شد ✅";

            }else{
                $res = "کانال مبدا از قبل ثبت شده است ‼️";
            }
        }

        $message->reply($res);

    }

    // # ---------  Del Channels
    #[FiltersAnd(
        new FiltersOr(new FilterOutgoing, new FilterFromAdmin),
        new FilterRegex("/^[\/\#\!]?(deletechannels) (.*)$/i")
    )]
    public function del_channel(Message $message): void
    {
        global $db;
        $TEXT = $message->message;
        preg_match("/^[\/\#\!]?(deletechannels) (.*)$/i", $TEXT, $Data);
        $chnnels = explode('|',$Data[2]);
        $MABDA = $chnnels[0];
        $MAQSAD = $chnnels[1];
        $result = $db->has('channels', ['mabda' => $MABDA , 'maqsad' => $MAQSAD]);
        foreach ($result as $row) {
            if($row['has'] == 0){
                $res = "چنین آیدی عددی در کانال های مبدا وجود ندارد ‼️";
            }else{
                $db->delete('channels', ['mabda' => $MABDA , 'maqsad' => $MAQSAD]);
                $res = "کانال مبدا و مقصد با موفقیت حذف شد ✅";
            }
        }
        
        $message->reply($res);

    }

    # --------- ChannelsList
    #[FiltersAnd(
        new FiltersOr(new FilterOutgoing, new FilterFromAdmin),
        new FilterText('channelslist')
    )]
    public function channels_list(Message $message): void
    {
        global $db;
        $TEXT = $message->message;
        $Peer = $message->senderId;
        $Id = $message->id;

        $result = $db->selectAll('channels', '*');

        $TEXT = "لیست کانال ها 📊 :";
        $TEXT .= "┣━━ $TEXT ━━| \n";
        
        $NUM = 0;
        foreach ($result as $row) {
            $NUM++;
            $column1 = $row['mabda'];
            $column2 = $row['maqsad'];
            $TEX = "\n┣ $column1 => $column2 \n";
            $TEXT .= $TEX;
        }
        $TEXT .= "┗━━━━━━━━━━━━";
            $message->reply(
                message: $TEXT,
                parseMode: ParseMode::HTML 
            );
    }

    #[FilterRegex('/join (.*)/i')]
    public function joinch(Incoming  & Message $message){
        $InputChannel = $message->matches[1];
        $this->channels->joinChannel(channel: $InputChannel, );
            $message->reply("ok");

    }
    #[FilterCommand('help')]

    public function helpCommand(Message $message): void
    {
        $Peer = $message->senderId;

$help  = "
*رهنمای استفاده از ربات:*

*خاموش و روشن کردن ربات*
`bot`  *[on & off ]*
*تست آنلاین بودن*
`ping`
*تازه سازی ربات * 
`restart`
* افزودن کانال مبدا و مقصد*
`channels` `-1001870751493|-1001945004094`

*حذف کانال های مبدا و مقصد*
`deletechannels` `-1001870751493|-1001945004094`

*کپی از هیستوری کانال*
`CopyH` `-1001639259313|-1002012888651`

*لیست کانال های مبدا و مقصد*
`channelslist`
";
            $message->reply(
                message: $help,
                parseMode: ParseMode::MARKDOWN
            );

    
    }

// -----------------------------------------------------------------------------------------

 
    # --------- Start_Copys 
    #[Handler]
    public function Start_Copys(Incoming  & ChannelMessage $message)

    {
        global $db;
        $TEXT = $message->message;
        $Peer = $message->senderId;
        $Id = $message->id;

        $result = $db->select('checkdata', 'bot', ['num' => 1])??"off";
        foreach ($result as $row) {
            $data = $row['bot']??"off";
        }
        if ($data == "on"){
        $result = $db->has('channels', ['mabda' => $Peer]);
        
        foreach ($result as $row) {
            if($row['has'] == 1){
                $data = "ok";
            }
        }
        
        
            if ($data == "ok") {
                $GropedId = $message->groupedId??0;
                $result = $db->select('channels', '*', ['mabda' => $Peer]);
                foreach ($result as $data) {
                
                    $maqsad = $data['maqsad'];
                    $mabda = $data['mabda'];
                    $Gp_id = $data['id']??0;
                    
    
                    $response = $this->channels->getMessages(channel: $mabda, id: [$Id], );
                    $HasForword = $response['chats'][0]['noforwards']?"True":"False";
                    $HasGroupId = $message->grouped_id??0;
                    
                    $message = $response['messages'][0];
                    $entities = $message['entities'] ??[] ;
    				@$type = $this->hasMedia2($message);
    				if($type == 'Text'){
    
                      	if ($TEXT != "" && $TEXT != null){
                            return $this->messages->sendMessage(['peer' => $maqsad,'entities' => $entities ??[],'message' => $TEXT??'-']);
                        }
    				}
        			if ($this->hasMedia($message) == false) {
        			    if($HasForword == "False"){
                            $this->messages->forwardMessages(
                                drop_author: true, 
                                drop_media_captions: false, 
                                noforwards: true, 
                                from_peer: $Peer,
                                id: [$Id],
                                to_peer: $maqsad,
                            );
                        }
                        else{
    
                            $output_file_name =  $this->downloadToDir($message, './Downloads/');
                            $typeMedia = $this->hasMedia2($message);
                            if($this->hasMedia2($message) == "Photo"){
        						 $this->messages->sendMedia(['peer' => $maqsad,'entities' => $entities ??[],'media' => ['_' => 'inputMediaUploadedPhoto', 'file' => $output_file_name],'message' => $TEXT ?? '']);
                            }elseif($typeMedia !== "documentAttributeVideo"){
                                $attributes = $message['media']['document']['attributes'];
    
                                $inputMediaUploadedDocument = [
                                    '_' => 'inputMediaUploadedDocument', 
                                    'file' => $output_file_name, 
                                    'attributes' => $attributes
                                ];
                                $sendMedia = $this->messages->sendMedia([
                                    // "reply_to" => $inputReplyToMessage,
                                    'peer' => $maqsad,
                                    'entities' => $entities ??[],
                                    'media' => $inputMediaUploadedDocument,
                                    'message' => $TEXT ?? ''
                                ]);
    
    
        				// 		$this->messages->sendMedia([
        				// 		    'peer' => $maqsad,'entities' => $entities ??[],'media' => ['_' => 'inputMediaUploadedDocument','file' => "$output_file_name",'attributes' => [['_' => 'documentAttributeFilename', 'file_name' => "file"]]],'message' => $TEXT ?? '']);
    
                                }
            			    unlink($output_file_name);
    
                        }
    
        			}
                    

    
                    			    
    			}
                
            }
        }

    }
 
    // public static function getPluginPaths(): string|array|null
    // {
    //     return 'plugins/';
    // }
}

$settings = new Settings;
$settings->getLogger()->setLevel(Logger::LEVEL_ULTRA_VERBOSE);

// You can also use Redis, MySQL or PostgreSQL.
// Data is migrated automatically.
//
// $settings->setDb((new Redis)->setDatabase(0)->setPassword('pony'));
// $settings->setDb((new Postgres)->setDatabase('MadelineProto')->setUsername('daniil')->setPassword('pony'));
// $settings->setDb((new Mysql)->setDatabase('MadelineProto')->setUsername('daniil')->setPassword('pony'));

// For users or bots
MyEventHandler::startAndLoop('SALEH', $settings);

// For bots only
// MyEventHandler::startAndLoopBot('bot.madeline', 'bot token', $settings);